function OLIM4VADvisualize()
u = load('Qpot.txt');
[m,n] = size(u);
xmin=-3.8; xmax = 4.2;
ymin = -4.0; ymax = 4.0;
x=linspace(xmin,xmax,n); y = linspace(ymin,ymax,m);
[xx,yy] = meshgrid(x,y);
ind = find(u>1e5);
u(ind) = NaN;
umax = max(max(u));
figure(1); clf;
colormap winter
contour(x,y,u,linspace(0,umax,20),'LineWidth',2);
colorbar
hold on
axis xy
f = load('Instanton.txt');
plot(f(:,1),f(:,2),'r','Linewidth',3);
t = linspace(0,2*pi,400);
plot(3*cos(t),3*sin(t),'--','Linewidth',2,'color','k');

step = 20;
Ix = 1 : step : n;
Iy = 1 : step : m;
[xx,yy] = meshgrid(x,y);
[bx,by] = myfield(xx,yy);
bnorm = sqrt(bx.*bx + by.*by);
xx(ind) = NaN;
yy(ind) = NaN;
bx(ind) = NaN;
by(ind) = NaN;
quiver(xx(Iy,Ix),yy(Iy,Ix),bx(Iy,Ix)./bnorm(Iy,Ix),by(Iy,Ix)./bnorm(Iy,Ix),'k');

daspect([1,1,1])
set(gca,'FontSize',16);
xlabel('x_1','FontSize',16);
ylabel('x_2','FontSize',16);
title('The quasi-potential, the instanton, and the field');
end
%%
function [bx,by] = myfield(x,y)
  r2 = x.*x + y.*y;
  aux = 1.0 - r2/9; % aux = 1 - r^2/9
  si = y./sqrt(r2); % aux1 = sin(theta)
  ffun = aux + si./r2;
  hfun = si - aux;
  bx = y.*hfun + x.*ffun;
  by = -x.*hfun + y.*ffun;
end

